var form_regexp = new Array();
form_regexp['ccnumber'] =  /^[3-6,8][0-9]{13,16}$/;
form_regexp['ccexp'] = /^((([1][0-2]|[0]?[1-9])[-\/]|([1][0-2]|[0][1-9]))(\d\d|\d\d\d\d)|0000)$/;
form_regexp['amount'] = /^[0-9]+\.[0-9]{2}$/;
form_regexp['cvv']=/^[0-9]{3,4}$/;
form_regexp['shipping'] = /^[0-9]+\.[0-9]{2}$/;
form_regexp['tax'] = /^[0-9]+\.[0-9]{2}$/;
//form_regexp['phone'] = /^[0-9,\-,\.]*$/;
form_regexp['phone'] = /^[0-9,\-,\.]{4,}$/;
form_regexp['fax'] = /^[0-9,\-,\.]*$/;
form_regexp['email'] = /^[a-zA-Z0-9,!#$%&'\*\+\/=\?\^_`\{\|\}~-]+(\.[a-zA-Z0-9,!#$%&'\*\+\/=\?\^_`\{\|\}~-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.([a-zA-Z]{2,6})$/;
form_regexp['url'] = /^([\w$-.+!*'()@:?=&\/;]+)$/;
form_regexp['shipping_email'] = form_regexp['email'];
form_regexp['orderid'] = /$/;
form_regexp['orderdescription'] = /$/;
form_regexp['firstname'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['lastname'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['address1'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['city'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['state'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['zip'] =  /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['transactionid'] = /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/; 
form_regexp['checkname'] = /^[a-z,A-Z,0-9,\.,\-, ,'_]*$/;
form_regexp['checkaba'] = /^[0-9]{9}$/;
form_regexp['checkaccount'] = /^[0-9]+$/;
form_regexp['plan_count'] = /^[0-5]/;


var form_title = new Array();
form_title['ccnumber'] = 'Credit Card Number';
form_title['ccexp'] =  'Expiration Date';
form_title['amount'] =  'Amount';
form_title['cvv'] = 'Card identifier';
form_title['shipping'] =  'Shipping Amount';
form_title['tax'] =  'Tax';
form_title['phone'] = 'Phone Number';
form_title['fax'] = 'Fax';
form_title['email'] = 'Email';
form_title['url'] = 'URL';
form_title['shipping_email'] = 'Shipping Email';
form_title['orderid'] = 'OrderID'; 
form_title['orderdescription'] = 'Order Description';
form_title['firstname'] = 'First Name';  
form_title['lastname'] = 'Last Name'; 
form_title['address1'] = 'Address'; 
form_title['city'] = 'City'; 
form_title['state'] = 'State'; 
form_title['zip'] = 'ZIP/Postal Code';
form_title['transactionid'] = 'Transaction ID';
form_title['checkname'] = 'Name on Account';
form_title['checkaba'] = 'Routing / ABA Number';
form_title['checkaccount'] = 'Account Number';
form_title['plan_count'] = 'Recurring Plan';

var form_msg = new Array();
form_msg['ccnumber'] = '(Card number must be between 13 and 16 characters)';
form_msg['ccexp'] = "(Card expiration should be in the format MMYY, MM/YY or MM-YY. Months may be one digit with a '/' or '-', and years maybe four digits)";
form_msg['amount'] =  '(ie 10.00)';
form_msg['cvv'] = '(Card identifier must be 3 or 4 numbers)';
form_msg['phone'] =  '(Please enter only numbers, dashes, and/or periods.)';

var required = new Array(); 
var optional = new Array(); 
required['credit_sale_required'] = ['ccnumber','ccexp','amount','firstname','lastname','address1','city','state','phone','email','zip'];
optional['credit_sale_optional'] = ['cvv','shipping','tax','shipping_email'];

required['credit_auth_required'] = ['ccnumber','ccexp','amount','firstname','lastname','address1','city','state','phone','email','zip'];
optional['credit_auth_optional'] = ['cvv','shipping','tax','shipping_email'];

required['credit_capture_required'] = ['transactionid','amount'];
optional['credit_capture_optional'] = [];

required['credit_void_required'] = ['transactionid'];
optional['credit_void_optional'] = [];

required['credit_refund_required'] = ['transactionid','amount'];
optional['credit_refund_optional'] = [];

required['ec_sale_required'] = ['checkname','checkaba','checkaccount','amount','firstname','lastname','address1','city','state','phone','email','zip'];
optional['ec_sale_optional'] = ['shipping','tax','shipping_email'];

required['cv_sale_required'] = ['amount'];
optional['cv_sale_optional'] = [];

required['cv_update_required'] = ['ccnumber','ccexp'];
optional['cv_update_optional'] = [];
function validate_form(form_req,form_opt)
{
    var req_empty = "ERROR: Required fields are empty\n";
    var req_invalid = "ERROR: Invalid Data\n";
    var opt_invalid = "ERROR: Invalid Optional Data\n";
    var isEmpty = false;
    var isInvalid = false;
    var isInvalidOpt = false;
    for (var i = 0; i < required[form_req].length; i++)   { 
        var temp = required[form_req][i];
        var val =document.getElementById(temp).value;
        if(val=="") {
            isEmpty = true;
            req_empty+=form_title[temp]+'\n';
        }
        else {
            var reg = form_regexp[temp];
            if(!reg.test(val)) {
                req_invalid+=form_title[temp]+' does not passed validation\n';
                isInvalid = true;
            }
        }
 
    }
    for (var i = 0; i < optional[form_opt].length; i++)   {
        var temp = optional[form_opt][i];
        var val =document.getElementById(temp).value;
        if(val!="") {
            var reg = form_regexp[temp];
            if(!reg.test(val)) {
                opt_invalid+=form_title[temp]+' does not passed validation\n';
                isInvalidOpt = true;
            }

        }
    }
    if(isEmpty || isInvalid || isInvalidOpt) {
        var msg = '';
        if(isEmpty)
        msg+=req_empty;
        if(isInvalid)
        msg+=req_invalid;
        if(isInvalidOpt)  
        msg+=opt_invalid;
        alert(msg);
        return false;
    }
    else 
        return true;
}
function validate_relement(id){
    var reg = form_regexp[id];
    var val = document.getElementById(id).value;
    if(!reg.test(val) || val=='') {
        document.getElementById(id+'_req').src = 'modules/Planetauthorize/images/required.gif';
        if(typeof(form_msg[id]) != "undefined")  
        document.getElementById(id+'_error').innerHTML = "<font font-size='8px' color='red'>Enter valid "+form_title[id]+'-'+form_msg[id]+'</font>';
        else
         document.getElementById(id+'_error').innerHTML = "<font font-size='8px' color='red'>Enter valid "+form_title[id]+'</font>';
    }
    else {
        document.getElementById(id+'_req').src = 'modules/Planetauthorize/images/approved.gif' 
        document.getElementById(id+'_error').innerHTML = '';
    }
}
function validate_element(id){
    var reg = form_regexp[id];
    var val = document.getElementById(id).value;
    if(val=="") {
        document.getElementById(id+'_error').innerHTML = '';
        return;
    }
    if(!reg.test(val)) {
        document.getElementById(id+'_req').style.display = 'none';
        if(typeof(form_msg[id]) != "undefined")
        document.getElementById(id+'_error').innerHTML = "<font font-size='8px' color='red'>Enter valid "+form_title[id]+'-'+form_msg[id]+'</font>';
        else
        document.getElementById(id+'_error').innerHTML = "<font font-size='8px' color='red'>Enter valid "+form_title[id]+'</font>';
    }
    else {
        document.getElementById(id+'_req').style.display = 'inline'
        document.getElementById(id+'_error').innerHTML = '';
    }
}
 
function data_copy(form)
{
if(form.copy.checked){
form.shipping_firstname.value=form.firstname.value;
form.shipping_lastname.value=form.lastname.value;
form.shipping_company.value=form.company.value;
form.shipping_address1.value=form.address1.value;
form.shipping_address2.value=form.address2.value;
form.shipping_city.value=form.city.value;
form.shipping_state.value=form.state.value;
form.shipping_email.value=form.email.value;
form.shipping_country.value=form.country.value;
form.shipping_zip.value=form.zip.value;
}
else {
form.shipping_firstname.value="";
form.shipping_lastname.value="";
form.shipping_company.value="";
form.shipping_address1.value="";
form.shipping_address2.value="";
form.shipping_city.value="";
form.shipping_state.value="";
form.shipping_email.value="";	
form.shipping_country.value="US";
form.shipping_zip.value="";	
}
}
function related_to(form) {
var i = form.entity.selectedIndex;
var module = form.entity.options[i].value;
clear_address(form);
if(module == 'Accounts') {
    document.getElementById('account_name').style.display = 'inline';
    document.getElementById('contact_name').style.display = 'none';
    document.getElementById('parent_name').style.display = 'none';
    window.open("index.php?module=" + module + "&action=Popup&popuptype=specific_account_address&form=EditView&form_submit=false","match","width=640,height=602,resizable=0,scrollbars=0");
}
if(module == 'Contacts') {
    document.getElementById('account_name').style.display = 'none';
    document.getElementById('contact_name').style.display = 'inline';
    document.getElementById('parent_name').style.display = 'none';
    window.open("index.php?module=" + module + "&action=Popup&popuptype=specific&form=EditView&form_submit=false","match","width=640,height=602,resizable=0,scrollbars=0");
}
if(module == 'Invoice') {
    document.getElementById('account_name').style.display = 'none';
    document.getElementById('contact_name').style.display = 'none';
    document.getElementById('parent_name').style.display = 'inline';
    window.open("index.php?module=" + module + "&action=Popup&form=EditView&form_submit=false","match","width=640,height=602,resizable=0,scrollbars=0");
}
}
function getListViewEntries_js(module,url)
{

        gstart = url;
        new Ajax.Request(
                'index.php',
                {queue: {position: 'end', scope: 'command'},
                        method: 'post',
                        postBody:"module="+module+"&action="+module+"Ajax&file=ListView&ajax=true&&"+url,
                        onComplete: function(response) {
                                $("status").style.display="none";
                        result = response.responseText.split('&#&#&#');
                                $("ListViewContents").innerHTML= result[2];
                                update_selected_checkbox();
                                if(result[1] != '')
                                        alert(result[1]);
                                $('basicsearchcolumns').innerHTML = '';
                        }
                }
        );
}
//Number
function isInteger(s)
{   var i;

    for (i = 0; i < s.length; i++)
    {
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) return false;
    }
    return true;
}
function set_return(planetauthorize_id, transaction_id) {
    if(document.getElementById('from_link').value != '') {
        window.opener.document.QcEditView.transactionid.value = transaction_id;
        window.opener.document.QcEditView.parent_id.value = planetauthorize_id;
    } else {
        window.opener.document.EditView.transactionid.value = transaction_id;
        window.opener.document.EditView.parent_id.value = product_id;
    }
}
function addvault()
{
    if(document.getElementById('add_vault').checked)
    document.getElementById('vault_id_block').style.display="inline";
    else
    document.getElementById('vault_id_block').style.display="none";
    
}
function show_billing()
{
    if(document.getElementById('billing').checked)
    document.getElementById('billing_block').style.display="inline";
    else
    document.getElementById('billing_block').style.display="none";
}
function countPlan()
{
    var ctr = 0;
    var mctr = 5; /* this is the maximum number of options you want selected */
    for (var i=0; i<document.getElementById('product_sku').length; i++)
    {
        if (document.getElementById('product_sku').options[i].selected==true)
            ctr++;
    }
    document.getElementById('plan_count').value=ctr;
    if (ctr>mctr)
    {
        alert("You have selected too many options, only " + mctr + " are permitted.");
        return false;
    }
    return true;
}
function fill_name()
{
    var temp = document.getElementById('contact_name').value;
    if(temp != "") {
    var name = temp.split(" ");
        document.getElementById('firstname').value = name[1];
        document.getElementById('lastname').value = name[0];
    }
    
}
function clear_address(form)
{
    form.firstname.value="";
    form.lastname.value="";
    form.company.value="";
    form.bill_street.value="";
    form.address2.value="";
    form.bill_city.value="";
    form.bill_state.value="";
    form.email.value="";
    form.country.value="US";
    form.bill_code.value="";
    //shipping
    form.shipping_firstname.value="";
    form.shipping_lastname.value="";
    form.shipping_company.value="";
    form.shipping_address1.value="";
    form.shipping_address2.value="";
    form.shipping_city.value="";
    form.shipping_state.value="";
    form.shipping_email.value="";
    form.shipping_country.value="US";
    form.shipping_zip.value="";

}
